//{ **************************************************************************** }
//{ FileName............: FASTMUTEXGUARD.H                                      }
//{ Project.............: Generic                                                }
//{ Author(s)...........: D.Beck                                                 }
//{ Original contents...:                                                        }
//{ Version.............: x.xx                                                   }
//{ ---------------------------------------------------------------------------- }
//{ Declarations for Fast Mutex scoped synchronization class wrapper.                           }
//{                                                                              }
//{ Version  Date      Comment                                                   }
//{ x.xx     20070310  - Initial release                                         }
//{ **************************************************************************** }

#ifndef FASTMUTEXGUARD_H
  #define FASTMUTEXGUARD_H

#include "stddcls.h"
#include "driver.h"

class FastMutexGuard
{
public:
  inline FastMutexGuard( PFAST_MUTEX fastMutex ) : fastMutex_( fastMutex ) 
  {
    ExAcquireFastMutex( fastMutex_ );
  };

  ~FastMutexGuard()
  {
    ExReleaseFastMutex( fastMutex_ );
  };
  
private:

  // hide default c-tor
  FastMutexGuard();

  PFAST_MUTEX fastMutex_;
};

#endif // FASTMUTEXGUARD_H