// DeviceList.h - Interface to CDeviceList class
// Copyright (C) 1999 by Walter Oney
// All rights reserved

#ifndef DEVICELIST_H
#define DEVICELIST_H

#include <string>
#include <vector>

#include <ace/Singleton.h>  

///////////////////////////////////////////////////////////////////////////////

class CDeviceListEntry
{								// class CDeviceListEntry
public:
	CDeviceListEntry(LPCTSTR linkname, LPCTSTR friendlyname);
	CDeviceListEntry(){}

  std::basic_string< TCHAR >		m_linkname;
  std::basic_string< TCHAR >		m_friendlyname;
};								// class CDeviceListEntry

///////////////////////////////////////////////////////////////////////////////

class CDeviceList
{								// class CDeviceList
public:
	CDeviceList();
	~CDeviceList();

	GUID	m_guid;				// the interface GUID for this list
  std::vector< CDeviceListEntry > m_list;	// list of devices

	int		Initialize(const GUID& guid);
};								// class CDeviceList

typedef ACE_Unmanaged_Singleton< CDeviceList, ACE_Thread_Mutex > DEVICE_LIST;

#endif